spfa判负环
算法分析
使用spfa算法解决是否存在负环问题
求负环的常用方法,基于SPFA,一般都用方法 2(该题也是用方法 2):
方法 1:统计每个点入队的次数,如果某个点入队n次,则说明存在负环
方法 2:统计当前每个点的最短路中所包含的边数,如果某点的最短路所包含的边数大于等于n,则也说明存在环
每次做一遍spfa()一定是正确的,但时间复杂度较高,可能会超时。初始时将所有点插入队列中可以按如下方式理解:
在原图的基础上新建一个虚拟源点,从该点向其他所有点连一条权值为0的有向边。那么原图有负环等价于新图有负环。此时在新图上做spfa,将虚拟源点加入队列中。然后进行spfa的第一次迭代,这时会将所有点的距离更新并将所有点插入队列中。执行到这一步,就等价于视频中的做法了。那么视频中的做法可以找到负环,等价于这次spfa可以找到负环,等价于新图有负环,等价于原图有负环。得证。
1、dist[x] 记录虚拟源点到x的最短距离
2、cnt[x] 记录当前x点到虚拟源点最短路的边数,初始每个点到虚拟源点的距离为0,只要他能再走n步,即cnt[x] >= n,则表示该图中一定存在负环,由于从虚拟源点到x至少经过n条边时,则说明图中至少有n + 1个点,表示一定有点是重复使用
3、若dist[j] > dist[t] + w[i],则表示从t点走到j点能够让权值变少,因此进行对该点j进行更新,并且对应cnt[j] = cnt[t] + 1,往前走一步
注意:该题是判断是否存在负环,并非判断是否存在从1开始的负环,因此需要将所有的点都加入队列中,更新周围的点
时间复杂度 一般:O(m) 最坏:O(nm)
链接:https://www.acwing.com/solution/content/6336/
1 #include<iostream> 2 #include<cstring> 3 #include<algorithm> 4 #include<queue> 5 using namespace std; 6 const int N=100010; 7 int ne[N],e[N],h[N],idx; 8 int w[N]; 9 int dist[N]; 10 int cnt[N]; 11 queue<int> q; 12 int n,m; 13 bool st[N]; 14 void insert(int a,int b,int c) 15 { 16 e[idx]=b; 17 w[idx]=c; 18 ne[idx]=h[a]; 19 h[a]=idx++; 20 } 21 int spfa() 22 { 23 for(int i=1;i<=n;i++) 24 { 25 st[i]=true; 26 q.push(i); 27 } 28 while(q.size()) 29 { 30 int t=q.front(); 31 q.pop(); 32 st[t]=false; 33 for(int i=h[t];i!=-1;i=ne[i]) 34 { 35 int j=e[i]; 36 cnt[j]=cnt[t]+1; 37 if(cnt[j]>=n) return 0; 38 if(dist[j]>dist[t]+w[i]) 39 { 40 dist[j]=dist[t]+w[i]; 41 if(!st[j]) 42 { 43 st[j]=true; 44 q.push(j); 45 } 46 } 47 } 48 } 49 return 1; 50 } 51 int main() 52 { 53 memset(h,-1,sizeof h); 54 scanf("%d%d",&n,&m); 55 while(m--) 56 { 57 int a,b,c; 58 scanf("%d%d%d",&a,&b,&c); 59 insert(a,b,c); 60 } 61 int ans=spfa(); 62 if(ans) puts("No"); 63 else puts("Yes"); 64 return 0; 65 }